"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _iterateJsdoc = _interopRequireDefault(require("../iterateJsdoc"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (0, _iterateJsdoc.default)(({
  jsdoc,
  report,
  utils
}) => {
  const targetTagName = 'example';

  const functionExamples = _lodash.default.filter(jsdoc.tags, {
    tag: targetTagName
  });

  if (utils.hasATag(['inheritdoc', 'override'])) {
    return;
  }

  if (utils.avoidExampleOnConstructors() && (utils.hasATag(['class', 'constructor']) || utils.isConstructor())) {
    return;
  }

  if (!functionExamples.length) {
    report('Missing JSDoc @' + targetTagName + ' declaration.');
    return;
  }

  functionExamples.forEach(example => {
    const exampleContent = _lodash.default.compact((example.name + ' ' + example.description).trim().split('\n'));

    if (!exampleContent.length) {
      report('Missing JSDoc @' + targetTagName + ' description.');
    }
  });
}, {
  meta: {
    type: 'suggestion'
  }
});

exports.default = _default;
module.exports = exports.default;
//# sourceMappingURL=requireExample.js.map